﻿Public Class ChangeCommand
    Implements ICommand
    Public Sub Execute(parameter As Object) Implements ICommand.Execute
        Dim person As Person = parameter

        person.Vorname = person.Vorname.ToUpper()
        person.Nachname = person.Nachname.ToUpper()
    End Sub

    Public Function CanExecute(parameter As Object) As Boolean Implements ICommand.CanExecute
        Dim person As Person = parameter
        Return person IsNot Nothing And
                Not String.IsNullOrWhiteSpace(person.Nachname) And
                Not String.IsNullOrWhiteSpace(person.Vorname)
    End Function

    Public Custom Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
        AddHandler(ByVal value As EventHandler)
            AddHandler CommandManager.RequerySuggested, value
        End AddHandler

        RemoveHandler(ByVal value As EventHandler)
            RemoveHandler CommandManager.RequerySuggested, value
        End RemoveHandler

        RaiseEvent(ByVal sender As System.Object, ByVal e As System.EventArgs)
        End RaiseEvent
    End Event
End Class
