﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Public Class Person
    Implements INotifyPropertyChanged

    Public Property ChangeCommand As ICommand = New ChangeCommand()

    Public Event PropertyChanged As PropertyChangedEventHandler _
            Implements INotifyPropertyChanged.PropertyChanged

    Private Sub SetProperty(<CallerMemberName> Optional propertyName As String = Nothing)
        If PropertyChangedEvent IsNot Nothing Then
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End If
    End Sub

    Private _vorname As String
    Public Property Vorname() As String
        Get
            Return _vorname
        End Get
        Set(ByVal value As String)
            _vorname = value
            SetProperty()
        End Set
    End Property

    Private _nachname As String
    Public Property Nachname() As String
        Get
            Return _nachname
        End Get
        Set(ByVal value As String)
            _nachname = value
            SetProperty()
        End Set
    End Property
    Private _geburtsdatum As DateTime
    Public Property Geburtsdatum() As DateTime
        Get
            Return _geburtsdatum
        End Get
        Set(ByVal value As DateTime)
            _geburtsdatum = value
            SetProperty()
        End Set
    End Property
End Class
