﻿Class MainWindow
    Sub New()
        InitializeComponent()

        DataContext = New Person() With
        {
            .Vorname = "Hans",
            .Nachname = "Muster",
            .Geburtsdatum = New DateTime(1990, 1, 1)
        }
    End Sub
    Public Sub ExecuteChangeCommand(sender As Object,
                                e As ExecutedRoutedEventArgs)
        Dim person As Person = Me.DataContext

        person.Vorname = person.Vorname.ToUpper()
        person.Nachname = person.Nachname.ToUpper()
    End Sub

    Public Sub CanExecuteChangeCommand(sender As Object,
                                e As CanExecuteRoutedEventArgs)
        Dim person As Person = Me.DataContext

        If person Is Nothing Then
            Return
        End If
        e.CanExecute =
            Not String.IsNullOrWhiteSpace(person.Nachname) And
            Not String.IsNullOrWhiteSpace(person.Vorname)
    End Sub

    Private Sub OnClose(sender As Object, e As ExecutedRoutedEventArgs)
        Application.Current.Shutdown()
    End Sub

    Private Sub OnCanClose(sender As Object, e As CanExecuteRoutedEventArgs)
        e.CanExecute = True
    End Sub
End Class
