﻿Imports System
Imports System.Collections.ObjectModel
Imports System.Globalization
Imports System.Xml

Public Class Currencies
    Inherits ObservableCollection(Of Currency)

    Private Shared _currencies As Currencies = New Currencies()

    Private Sub New()
    End Sub

    Public Property [Date] As DateTime

    Public Shared Function Load() As Currencies
        _currencies.Clear()
        Dim address As String = $"http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml"
        _currencies.Add(New Currency("EUR", 1D))

        Using r = New XmlTextReader(address)

            While r.Read()

                If r.NodeType = XmlNodeType.Element Then

                    If r.Name.Equals("Cube") Then
                        Dim d As String = r.GetAttribute("time")

                        If d IsNot Nothing Then
                            _currencies.Date = DateTime.Parse(d)
                        ElseIf r.GetAttribute("currency") IsNot Nothing Then
                            Dim currencyCode As String = r.GetAttribute("currency")
                            Dim rateString As String = r.GetAttribute("rate")
                            Dim rate = Decimal.Parse(rateString, CultureInfo.InvariantCulture)
                            Dim currency = New Currency(currencyCode, rate)
                            _currencies.Add(currency)
                        End If
                    End If
                End If
            End While
        End Using

        Return _currencies
    End Function
End Class

