﻿Public Class TextBoxTraceListener
    Inherits TraceListener

    Private textBox As TextBox

    Sub New()
        textBox = New TextBox() With
        {
            .TextWrapping = TextWrapping.Wrap
        }

        Dim window = New Window()
        Dim scrollViewer = New ScrollViewer() With
        {
            .HorizontalScrollBarVisibility = ScrollBarVisibility.Auto,
            .VerticalScrollBarVisibility = ScrollBarVisibility.Auto,
            .Content = textBox
        }
        window.Content = scrollViewer
        window.Show()
    End Sub

    Public Overrides Sub Write(message As String)
        textBox.Text += message
    End Sub

    Public Overrides Sub WriteLine(message As String)
        textBox.Text += message + vbCrLf
    End Sub
End Class
