﻿Imports System.Collections.ObjectModel
Imports System.IO

Public Class Picture
    Public Property Name As String
    Public Property BitmapImage As BitmapImage
    Public Property DateCreated As DateTime
    Public Property Path As String
    Public Property FileType As String
End Class

Public Class PictureList
    Inherits ObservableCollection(Of Picture)

    Sub New()
        Refresh()
    End Sub

    Private Sub Refresh()
        Dim pathPictures As String = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)
        Dim fileNames As String() = Directory.GetFiles(pathPictures, "*.png")

        For Each fileName In fileNames
            Dim bitmap = New BitmapImage()

            bitmap.BeginInit()
            bitmap.UriSource = New Uri(fileName)
            bitmap.DecodePixelWidth = 100
            bitmap.EndInit()

            Me.Add(New Picture() With
            {
                .Name = Path.GetFileNameWithoutExtension(fileName),
                .BitmapImage = bitmap,
                .DateCreated = File.GetCreationTime(fileName),
                .Path = fileName,
                .FileType = Path.GetExtension(fileName)
            })
        Next
    End Sub
End Class