﻿Enum RGB
    R
    G
    B
End Enum
Class MainWindow
    Sub New()
        InitializeComponent()

        For Each rgb As RGB In [Enum].GetValues(GetType(RGB))
            CreateColorItems(rgb)
        Next

    End Sub

    Private Sub CreateColorItems(rgb As RGB)
        Dim r = 0, g = 0, b = 0, a = &HFF

        For value = 255 To 1 Step -1
            If rgb = RGB.R Then
                r = value
            End If
            If rgb = RGB.G Then
                g = value
            End If
            If rgb = RGB.B Then
                b = value
            End If

            Dim color As Color = Color.FromArgb(a, r, g, b)

            Dim button As Button = New Button() With
        {
            .ToolTip = $"#{a,2:x2}{r,2:x2}{g,2:x2}{b,2:x2}",
            .Background = New SolidColorBrush(color),
            .BorderThickness = New Thickness(0.0),
            .Height = 25,
            .Width = 25
        }
            AddHandler button.Click, AddressOf OnChangeColor
            panel.Children.Add(button)

        Next

    End Sub

    Private Sub OnChangeColor(sender As Object, e As RoutedEventArgs)
        Dim button As Button = sender
        previewColor.Fill = button.Background
    End Sub
End Class
