﻿Class MainWindow
    Dim _cursor As Cursor
    Dim _x1 As Double, _x2 As Double,
        _y1 As Double, _y2 As Double
    Dim _shape As Shape

    Sub New()
        InitializeComponent()
        _cursor = Application.Current.MainWindow.Cursor
    End Sub
    Private Sub OnPressed(sender As Object, e As MouseButtonEventArgs)
        Application.Current.MainWindow.Cursor = Cursors.Cross

        _x1 = e.GetPosition(canvas).X
        _y1 = e.GetPosition(canvas).Y
        _x2 = _x1
        _y2 = _y1

        _shape = New Ellipse()

        _shape.Width = _x2 - _x1
        _shape.Height = _y2 - _y1
        _shape.StrokeThickness = 3
        _shape.Stroke = Brushes.Blue
        _shape.Fill = Brushes.Red

        canvas.Children.Add(_shape)
    End Sub

    Private Sub OnMoved(sender As Object, e As MouseEventArgs)
        If _shape Is Nothing Then
            Return
        End If

        _x2 = e.GetPosition(canvas).X
        _y2 = e.GetPosition(canvas).Y

        Canvas.SetLeft(_shape, If(_x2 > _x1, _x1, _x2))
        Canvas.SetTop(_shape, If(_y2 > _y1, _y1, _y2))

        _shape.Width = Math.Abs(_x2 - _x1)
        _shape.Height = Math.Abs(_y2 - _y1)
    End Sub

    Private Sub OnReleased(sender As Object, e As MouseButtonEventArgs)
        Application.Current.MainWindow.Cursor = _cursor
        _shape = Nothing
    End Sub

End Class
