﻿Imports System.Collections.ObjectModel
Imports System.IO

Public Class Picture
    Public Property Name As String
    Public Property BitmapImage As BitmapImage
    Public Property DateCreated As DateTime
    Public Property Path As String
    Public Property FileType As String
End Class

Public Class PictureList
    Inherits ObservableCollection(Of Picture)

    Sub New(pathDirectory As String)
        Refresh(pathDirectory)
    End Sub

    Private Sub Refresh(pathDirectory As String)
        Dim directories As String() = Directory.GetDirectories(pathDirectory)

        Dim uri = New Uri("/Assets/Directory.png", UriKind.Relative)

        For Each directory As String In directories

            Me.Add(New Picture With
              {
                .BitmapImage = New BitmapImage(uri),
                .Name = directory.Substring(directory.LastIndexOf("\") + 1),
                .Path = directory
              })
        Next

        Dim fileNames As String() = Directory.GetFiles(pathDirectory, "*.png")

        For Each fileName In fileNames
            Dim bitmap = New BitmapImage()

            bitmap.BeginInit()
            bitmap.UriSource = New Uri(fileName)
            bitmap.DecodePixelWidth = 100
            bitmap.EndInit()

            Me.Add(New Picture() With
            {
                .Name = Path.GetFileNameWithoutExtension(fileName),
                .BitmapImage = bitmap,
                .DateCreated = File.GetCreationTime(fileName),
                .Path = fileName,
                .FileType = Path.GetExtension(fileName)
            })
        Next
    End Sub
End Class