﻿Class PictureGalleryPage

    Sub New()
        Me.New(Nothing)
    End Sub

    Sub New(pathDirectory As String)
        InitializeComponent()

        If pathDirectory Is Nothing Then
            pathDirectory = Environment.GetLogicalDrives()(1)
        End If

        WindowTitle = pathDirectory
        Title = pathDirectory

        Dim pictureList = New PictureList(pathDirectory)

        If pictureList.Count = 0 Then
            Content = New TextBlock() With
              {
                .Text = "keine Bilddateien gefunden",
                .HorizontalAlignment = HorizontalAlignment.Center,
                .VerticalAlignment = VerticalAlignment.Center
              }
            Return
        End If
        gallery.ItemsSource = pictureList

    End Sub

    Private Sub OnDetails(sender As Object, e As MouseButtonEventArgs)
        Dim picture As Picture = gallery.SelectedItem

        If picture.FileType Is Nothing Then 'Ordner
            Dim page = New PictureGalleryPage(picture.Path)
            NavigationService.Navigate(page)
            Application.Current.MainWindow.DataContext = Nothing
        Else
            Application.Current.MainWindow.DataContext = picture
        End If
    End Sub
End Class
