﻿Imports Microsoft.Win32

Class MainWindow
    Sub New()
        InitializeComponent()
        stretchMode.ItemsSource = [Enum].GetNames(GetType(Stretch))
        stretchMode.SelectedIndex = 0
    End Sub

    Private Sub OnSelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        Dim stretch As Stretch = [Enum].Parse(GetType(Stretch), stretchMode.SelectedValue)
        image.Stretch = stretch
    End Sub

    Private Sub OnOpenFile(sender As Object, e As RoutedEventArgs)
        Dim dialog = New OpenFileDialog()

        dialog.InitialDirectory = Environment.GetFolderPath(
                Environment.SpecialFolder.CommonPictures)

        dialog.Filter = "Bilddateien|*.bmp;*.png;*.jpg;*.jpeg"

        If dialog.ShowDialog(Me) = True Then
            Dim uri = New Uri(dialog.FileName)

            Dim bitmap = New BitmapImage(uri)
            image.Source = bitmap
        End If
    End Sub


End Class
